<?php

namespace Drupal\lupus_decoupled_api_log;

use Drupal\rest_log\RestLogRouteCheckInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\RequestStack;

/**
 * Connects lupus_decoupled api requests and responses with rest_log.
 */
final class ApiLogRouteCheck implements RestLogRouteCheckInterface {

  /**
   * Constructs an ApiLogRouteCheck object.
   */
  public function __construct(
    private readonly RequestStack $requestStack,
  ) {}

  /**
   * {@inheritDoc}
   */
  public function applies() {
    return $this->isApiResponse($this->requestStack->getCurrentRequest());
  }

  /**
   * Determines if we are serving an api response.
   *
   * @return bool
   *   Returns TRUE if we are serving an api response.
   */
  protected function isApiResponse(Request $request): bool {
    return $request->attributes->get('lupus_ce_renderer') || $request->getRequestFormat() == 'custom_elements';
  }

}
